{% extends "admin_site/client_base.html" %}
{% load static staticfiles widget_tweaks%}
{% block title %}Users List{% endblock %}
{% block content %}
    <script src="https://js.stripe.com/v3/"></script>
    <script src="{% static "webtweaker_assets/js/index.js" data-rel-js %}"></script>
    <link rel="stylesheet" type="text/css" href="{% static 'webtweaker_assets/css/example5.css' %}" data-rel-css=""/>
    <link rel="stylesheet" type="text/css" href="{% static 'webtweaker_assets/css/base.css' %}" data-rel-css=""/>
    <link rel="stylesheet" type="text/css" href="{% static 'webtweaker_assets/css/example5.css' %}" data-rel-css=""/>
{%  endblock %}
{% block container %}
    <div class="row align-items-center justify-content-center">
        <div class="col-lg-6 col-md-6 mb-4">
            <!--Card-->
            <div class="card card-cascade narrower">
                <!--Card content-->
                <div class="view view-cascade gradient-card-header mdb-color lighten-3">
                        <h5 class="mb-0 font-weight-bold">Upgrade Payment</h5>
                </div>
                <div class="card-body card-cascade text-center">
                <form id="payment">
                    <!-- Register form -->
                     <div style="margin-top: 20px">
                        <select class="form-control" style="display: block !important;" id ="package">
                            {% for package in packages %}
                            <option  value="{{ package.price }}">{{ package.name }}</option>
                            {% endfor %}
                        </select>
                    </div>
                  <div style="margin-top: 20px" >
                        <select class="form-control" style="display: block !important;" id ="duration">

                            <option  value="1">Monthly</option>
                            <option  value="12">Yearly</option>

                        </select>
                    </div>
                    <div style="margin-top: 20px" >
                            <input class="form-control" id="price" value="{{ packages.0.price }}" disabled>
                     </div>
                    <div style="margin-top: 20px">
                            <div class="form-control" id="card-element"></div>
                        <div id="card-errors" role="alert"></div>
                    </div>

                    <button style="margin-top: 20px" type="submit" data-tid="elements_examples.form.pay_button" class="form-control">
                        Pay
                    </button>
                    </form>
                    <!-- Register form -->

                </div>

            </div>
            <!--/.Card-->

        </div>
    </div>
{% endblock %}

{% block custom_js %}
    <script>
        $('#package').change(function () {
            $('#price').val($(this).val());
        });
        $('#duration').change(function () {
            var price = $('#package').val() * $(this).val();
            $('#price').val(price);
        });
        var stripe = Stripe('{{ STRIPE_PUBLISHABLE_KEY }}');
        var elements = stripe.elements();

        var style = {
            base: {
                iconColor: "#658af9",
                color: "#5766ff",
                fontWeight: 400,
                fontFamily: "Helvetica Neue, Helvetica, Arial, sans-serif",
                fontSize: "16px",
                fontSmoothing: "antialiased",
                "::placeholder": {
                    color: "#453bf6"
                },
                ":-webkit-autofill": {
                    color: "#fce883"
                }
            },
            invalid: {
                iconColor: "#ff3645",
                color: "#ff2644"
            }
        };

        // Create an instance of the card Element.
        var card = elements.create('card', {
            style: style
        });

        // Add an instance of the card Element into the `card-element` <div>.
        card.mount('#card-element');
        card.addEventListener('change', function (event) {
            var displayError = document.getElementById('card-errors');
            if (event.error) {
                displayError.textContent = event.error.message;
            } else {
                displayError.textContent = '';
            }
        });

        // Create a source or display an error when the form is submitted.
        var form = document.getElementById('payment');

        form.addEventListener('submit', function (event) {
            event.preventDefault();

            stripe.createSource(card).then(function (result) {
                if (result.error) {
                    // Inform the user if there was an error
                    var errorElement = document.getElementById('card-errors');
                    errorElement.textContent = result.error.message;
                } else {
                    // Send the source to your server
                    stripeSourceHandler(result.source);
                }
            });
        });

        function stripeSourceHandler(source) {
            // Insert the source ID into the form so it gets submitted to the server
            var form = document.getElementById('payment');
            var hiddenInput = document.createElement('input');
            var hiddenAmount = document.createElement('input');

            hiddenInput.setAttribute('type', 'hidden');
            hiddenInput.setAttribute('name', 'stripeSource');
            hiddenInput.setAttribute('value', source.id);
            form.appendChild(hiddenInput);

            hiddenAmount.setAttribute('type', 'hidden');
            hiddenAmount.setAttribute('name', 'amt');
            hiddenAmount.setAttribute('value', '{{ order_total.incl_tax|safe }}');
            form.appendChild(hiddenAmount);

            // Submit the form
            {#form.submit();#}
            var amount = $('#package').val();
            var duration = $('#duration').val();
            $.ajax({
                url:"{% url 'admin_site:upgrade-payment' %}",
                type: 'post',
                data: { token: source.id, csrfmiddlewaretoken: '{{ csrf_token }}',amount:amount, duration: duration},
                success: function (response) {
                    window.location.href = 'admin/user_payment_history/';
                    var example = document.querySelector(".example5");
                    example.querySelector(".token").innerText = source.id;
                    example.classList.add("submitted");
                    {#source.complete("success");#}
                    $('#test').append('<a href="{% url 'admin_site:dashboard' %}" class="alert alert-success" role="alert">You are successfully subscribed to Webtweaker. Click here to visit your admin panel</a>');
                },
                error:function(data){
                    var error_message = data.responseText.split(":")[1].split("\n")[0];
                    $('#test').append('<div class="alert alert-error" role="alert">'+error_message+'</div>');
                }
            });
        }
        $('#amount').text(sessionStorage.amount);
    </script>
{% endblock %}